<?php
require_once "db.php";
function _pg_checkbool(&$res,&$ary){
 if (!is_array($ary)) return ;
 $flds=pg_num_fields($res);
 for($i=0;$i<$flds;$i++) if (pg_field_type($res,$i)=='bool') {
  if (array_key_exists($i,$ary)) {
   if ($ary[$i]=='t') $ary[$i]=true; else
   if ($ary[$i]=='f') $ary[$i]=false;
  }
  $fn=pg_field_name($res,$i);
  if (array_key_exists($fn,$ary)) {
   if ($ary[$fn]=='t') $ary[$fn]=true; else
   if ($ary[$fn]=='f') $ary[$fn]=false;
  }
 };
}
function _pg_errorfatal($s,$die=true){
 $bta=debug_backtrace();
 $bt=var_export($bta,true);
 mail("wlad@ctcs.ru","pg fatal error","Message: $s\nBacktrace:\n".$bt,"From: \"Robot\" <robots@ctcs.ru>\nTo: <wlad@ctcs.ru>");
 if ($die) die($s);
}

class Query_pg extends Query {
 var $qry,$numflds,$fldtypes,$fldnames;
 function Query_pg($_qry){
  $this->qry=$_qry;
  $this->numflds=pg_num_fields($this->qry);
  $this->fldtypes=array();
  $this->fldnames=array();
  for($i=0;$i<$this->numflds;$i++) {
   $this->fldtypes[]=pg_field_type($this->qry,$i);
   $this->fldnames[]=pg_field_name($this->qry,$i);
  }
 }
 function _Query_pg(){
  if (!is_null($this->qry)) pg_free_result($this->qry);
  $this->qry=null;
 }
 function __destruct(){
  $this->_Query_pg();
 }
 function _pg_checkbool(&$ary){
  if (!is_array($ary)) return ;
  for($i=0;$i<$this->numflds;$i++) if ($this->fldtypes[$i]=='bool') {
   if (array_key_exists($i,$ary)) {
    if ($ary[$i]=='t') $ary[$i]=true; else
    if ($ary[$i]=='f') $ary[$i]=false;
   }
   $fn=$this->fldnames[$i];
   if (array_key_exists($fn,$ary)) {
    if ($ary[$fn]=='t') $ary[$fn]=true; else
    if ($ary[$fn]=='f') $ary[$fn]=false;
   }
  };
 }
 function fetchRow(){
  $rw=pg_fetch_row($this->qry);
  $this->_pg_checkbool($rw);
  return $rw;
 }
 function fetchAssoc(){
  $rw=pg_fetch_assoc($this->qry);
  $this->_pg_checkbool($rw);
  return $rw;
 }
 function get_numfields(){
  return $this->numflds;
 }
 function get_fieldname($fieldno){
  return pg_field_name($this->qry, $fieldno);
 }
}
class DB_pg extends DB {
 var $con;
 var $started;
 var $cntq;
 var $silent_errors;
 var $in_tran;
 function DB_pg(){
  $this->con=null;
  $this->cntq=0;
  $this->silent_errors=false;
 }
 function _DB_pg(){
  $this->disconnect();
 }
 function _prepsql($sql,$binds){
  if (!is_array($binds)) return $sql;
  if (count($binds)<1) return $sql;
  for($i=0;$i<count($binds);$i++){
   $sql=preg_replace("/:".($i+1)."\\b/",$this->str_escape($binds[$i]),$sql);
  }
  return $sql;
 }
 function __destruct(){
  $this->disconnect();
 }
 function disconnect(){
  if (!is_null($this->con)) pg_close($this->con);
  $this->con=null;
 }
 function connect($params){
  $dsn="";
  $this->started=microtime(true);
  $this->cntq=0;
  foreach($params as $k=>$v) $dsn.="$k=$v ";
  $this->con=pg_pconnect($dsn);
  if (!$this->con) _pg_errorfatal(pg_last_error());
  $this->in_tran=false;
  pg_query($this->con,'SET SESSION CHARACTERISTICS AS TRANSACTION ISOLATION LEVEL READ COMMITTED');
 }
 function transaction($ro=false){
 	if ($this->in_tran) $this->commit();
  pg_query($this->con,'BEGIN TRANSACTION ISOLATION LEVEL READ UNCOMMITTED READ '.($ro ? 'ONLY':'WRITE'));
  $this->in_tran=true;
  $this->cntq+=1;
 }
 function rollback(){
 	if (!$this->in_tran) return ;
  pg_query($this->con,'rollback work');
  $this->in_tran=false;
  $this->cntq+=1;
 }
 function commit(){
 	if (!$this->in_tran) return ;
  pg_query($this->con,'commit work');
  $this->in_tran=false;
  $this->cntq+=1;
 }
 function execute($sql,$binds=null){
  $res=pg_query($this->con,$this->_prepsql($sql,$binds));
  if (!$res) {
   if ($this->silent_errors) return false;
   _pg_errorfatal(pg_last_error($this->con));
  }
  $this->cntq++;
  return true;
 }
 function query($sql,$binds=null){
  $res=pg_query($this->con,$this->_prepsql($sql,$binds));
  if (!$res) {
   if ($this->silent_errors) return null;
   _pg_errorfatal(pg_last_error($this->con));
  }
  $this->cntq++;
  $ret=new Query_pg($res);
  return $ret;
 }
 function queryOneRow($sql,$binds=null){
  $res=pg_query($this->con,$this->_prepsql($sql,$binds));
  if (!$res) {
   if ($this->silent_errors) return null;
   _pg_errorfatal(pg_last_error($this->con));
  }
  $this->cntq++;
  $ret=pg_fetch_array($res);
  _pg_checkbool($res,$ret);
  pg_free_result($res);
  return $ret;
 }
 function queryOneRowAssoc($sql,$binds=null){
  $res=pg_query($this->con,$this->_prepsql($sql,$binds));
  if (!$res) {
   if ($this->silent_errors) return null;
   _pg_errorfatal(pg_last_error($this->con));
  }
  $this->cntq++;
  $ret=pg_fetch_assoc($res);
  _pg_checkbool($res,$ret);
  pg_free_result($res);
  return $ret;
 }
 function _getstat(){
  $nw=microtime(true);
  return $this->cntq.' queries '.($nw-$this->started).' secs';
 }
}
?>