<?php
if ((intval(2 << 40) >> 40)==2){
define(NATIVE_64BIT,1);
define(USE_GMP,0);
} else {
define(NATIVE_64BIT,0);
define(USE_GMP,1);
}

function parse_hex($s){
	$r=0;
	for($i=0;$i<strlen($s);$i++){
		$r*=16;
		if ($s[$i]>='0' && ($s[$i]<='9')) $r+=ord($s[$i])-ord('0');
		if ($s[$i]>='a' && ($s[$i]<='f')) $r+=ord($s[$i])-ord('a')+10;
		if ($s[$i]>='A' && ($s[$i]<='F')) $r+=ord($s[$i])-ord('A')+10;
	}
	return $r;
}
class InetAddr {
	var $b;
	var $gcs;
	
	function InetAddr(){
	    if (USE_GMP){
	    $this->gcs=array(
		48=>gmp_pow("2",48),
		32=>gmp_pow("2",32),
		16=>gmp_pow("2",16)
	    );
	    }
	}

	function parse($str){
		if (preg_match("/^([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$/",$str,$m)) {
			if (!preg_match("/^[0-9]+$/",$m[1]) || !preg_match("/^[0-9]+$/",$m[2]) || !preg_match("/^[0-9]+$/",$m[3]) || !preg_match("/^[0-9]+$/",$m[4])) return null;
			$m[1]=intval($m[1]);$m[2]=intval($m[2]);$m[3]=intval($m[3]);$m[4]=intval($m[4]);
			if (($m[1]<0) || ($m[1]>255) || ($m[2]<0) || ($m[2]>255) || ($m[3]<0) || ($m[3]>255) || ($m[4]<0) || ($m[4]>255)) return null;
			$this->b=(intval($m[1]) << 24) | (intval($m[2]) << 16) | (intval($m[3]) << 8) | intval($m[4]);
			return $this;
	  }
	  if($str=="::"){
	    $this->b=array(0,0);
	    return $this;
	  }
		if (preg_match("/^[0-9a-fA-F\:]+$/",$str)) {
			$m=explode(":",$str);
			if ((count($m)<2) || (count($m)>8)) return null;
			$c=0;
			//print_r($m);
			for($i=0;$i<count($m);$i++) if (strlen($m[$i])>4) return null; else if (!strlen($m[$i])) $c++;
			if ($c>2) return null;
			$q=array(0,0,0,0,0,0,0,0);
			$p=0;
			for($i=0;$i<count($m);$i++){
				if (strlen($m[$i])){
					$q[$p++]=parse_hex($m[$i]);
				} else $p=9-(count($m)-$i);
			}
			if (NATIVE_64BIT){
			    $this->b=array((($q[0] << 48) | ($q[1] << 32) | ($q[2] << 16) | $q[3]),(($q[4] << 48) | ($q[5] << 32) | ($q[6] << 16) | $q[7]));
			} else
			if (USE_GMP){
			    $this->b=array(0,0);
			    for($i=0;$i<2;$i++){
				$this->b[$i]=gmp_mul($q[$i*4],$this->gcs[48]);
				$this->b[$i]=gmp_add($this->b[$i],gmp_mul($q[$i*4+1],$this->gcs[32]));
				$this->b[$i]=gmp_add($this->b[$i],gmp_mul($q[$i*4+2],$this->gcs[16]));
				$this->b[$i]=gmp_add($this->b[$i],$q[$i*4+3]);
			    }
			}
			return $this;
		}
		return null;
	}
	function hostaddr(){
		if (is_null($this->b)) return null;
		if (!is_array($this->b)){
		    $i0=($this->b >> 24) & 255;
		    $i1=($this->b >> 16) & 255;
		    $i2=($this->b >> 8) & 255;
		    $i3=$this->b & 255;
		    return sprintf("%u.%u.%u.%u",$i0,$i1,$i2,$i3);
		}
		$q=array(0,0,0,0,0,0,0,0);
		if (NATIVE_64BIT){
		for($i=0;$i<2;$i++){
			$q[$i*4]=($this->b[$i] >> 48) & 65535;
			$q[$i*4+1]=($this->b[$i] >> 32) & 65535;
			$q[$i*4+2]=($this->b[$i] >> 16) & 65535;
			$q[$i*4+3]=$this->b[$i] & 65535;
		}
		} else
		if (USE_GMP){
		    for($i=0;$i<2;$i++)
			if (!is_resource($this->b[$i])) $this->b[$i]=gmp_init(''.$this->b[$i]);
		    for($i=0;$i<2;$i++){
			$rs=gmp_div_qr($this->b[$i],$this->gcs[48]);
			$q[$i*4]=gmp_intval($rs[0]);
			$rs=gmp_div_qr($rs[1],$this->gcs[32]);
			$q[$i*4+1]=gmp_intval($rs[0]);
			$rs=gmp_div_qr($rs[1],$this->gcs[16]);
			$q[$i*4+2]=gmp_intval($rs[0]);
			$q[$i*4+3]=gmp_intval($rs[1]);
		    }
		}
	if($q[0]==0 && $q[1]==0 && $q[2]==0 && $q[3]==0 && $q[4]==0 && $q[5]==0 && $q[6]==0 && $q[7]==0){
	    return "::";
	}
	if($q[0]==0 && $q[1]==0 && $q[2]==0 && $q[3]==0 && $q[4]==0 && $q[5]==65535){
		    $i0=($q[6] >> 8) & 255;
		    $i1=($q[6]) & 255;
		    $i2=($q[7] >> 8) & 255;
		    $i3=$q[7] & 255;
	    return sprintf("::ffff:%u.%u.%u.%u",$i0,$i1,$i2,$i3);
	}
	  //return sprintf("%x:%x:%x:%x:%x:%x:%x:%x",$q[0],$q[1],$q[2],$q[3],$q[4],$q[5],$q[6],$q[7]);
	  $f=0;$l=0;$cp=-1;$cc=0;
	  for($i=0;$i<8;$i++) if ($q[$i]) {
	  	if ($cp>=0){
	  		if ($cc>$l) $f=$cp;$l=$cc;
	  	}
	  	$cp=-1;$cc=0;
	  } else {
	  	if ($cp<0) {$cp=$i;$cc=0;}
	  	$cc++;
	  }
  	if ($cp>=0){
  		if ($cc>$l) $f=$cp;$l=$cc;
  	}
	  if ($l<2)
	  	return sprintf("%x:%x:%x:%x:%x:%x:%x:%x",$q[0],$q[1],$q[2],$q[3],$q[4],$q[5],$q[6],$q[7]);
		$ret="";
		for($i=0;$i<$f;$i++) $ret.=sprintf("%x:",$q[$i]);
		if ($f+$l>=8) $ret.=':'; else for($i=$f+$l;$i<8;$i++) $ret.=sprintf(":%x",$q[$i]);
		return $ret;
	}
	function str(){
		return $this->hostaddr();
	}
	function is_equal($adr){
		if (!is_object($adr)) return false;
		if (get_class($adr)!='InetAddr' && !is_subclass_of($adr,'InetAddr')) return false;
		if (USE_GMP){
			if (!is_array($this->b)) return gmp_cmp($this->b,$adr->b)==0;
			return gmp_cmp($this->b[0],$adr->b[0])==0 && gmp_cmp($this->b[1],$adr->b[1])==0;
		}
		if (!is_array($this->b)) return $this->b==$adr->b;
		return $this->b[0]==$adr->b[0] && $this->b[1]==$adr->b[1];
	}
	function increment(){
		if (!is_array($this->b)) {$this->b++;return $this;}
		if (is_resource($this->b[1])) $this->b[1]=gmp_add($this->b[1],1); else $this->b[1]++;
		//TODO: overflow
		return $this;
	}
	function add($n){
		if (!is_array($this->b)) {$this->b+=$n;return $this;}
		if (is_resource($this->b[1])) $this->b[1]=gmp_add($this->b[1],$n); else $this->b[1]+=$n;
		//TODO: overflow
		return $this;
	}
	function get_i1(){
	    return is_array($this->b) ? (is_resource($this->b[0]) ? gmp_strval($this->b[0]):'0'.$this->b[0]):$this->b;
	}
	function get_i2(){
	    return is_array($this->b) ? (is_resource($this->b[1]) ? gmp_strval($this->b[1]):'0'.$this->b[1]):null;
	}
	function get_u1(){
	    $r=(is_array($this->b) ? (is_resource($this->b[0]) ? gmp_strval($this->b[0]):'0'.$this->b[0]):$this->b);
	    //if ($r<0) return 4294967296+$r;
	    return $r;
	}
	function get_u2(){
	    $r=is_array($this->b) ? (is_resource($this->b[1]) ? gmp_strval($this->b[1]):'0'.$this->b[1]):null;
	    if (is_null($r)) return $r;
	    //$r=floatval($r);
	    //if ($r<0) return 4294967296+$r;
	    return $r;
	}
	function get_proto(){return is_array($this->b) ? 6:4;}
	function assign($i1,$i2=null){
		if (is_object($i1)){
		 if (get_class($i1)!='InetAddr' && !is_subclass_of($i1,'InetAddr')) return false;
		 $this->b=$i1->b;
		 return true;
		}
		if (is_array($i1)){
			$i2=$i1[1];
			$i1=$i1[0];
		}
		if (!is_null($i2)) $this->b=array($i1,$i2); else $this->b=$i1;
	}
};
class InetNet extends InetAddr {
	var $preflen;
	
	function assign($i1,$i2=null,$pfl=null){
		if (is_object($i1)){
		 if (get_class($i1)=='InetNet' || is_subclass_of($i1,'InetNet')){
		 	$this->b=$i1->b;
		 	$this->preflen=$i1->preflen;
		 	return ;
		 }
		 if (get_class($i1)=='InetAddr' || is_subclass_of($i1,'InetAddr')){
		 	$this->b=$i1->b;
		 	$this->preflen=$i1->get_proto()==6 ? 128:32;
		 	return ;
		 }
		}
		if (is_array($i1)){
			$pfl=$i1[2];
			$i2=$i1[1];
			$i1=$i1[0];
		}
		if (USE_GMP){
		if (is_string($i1)) $i1=floatval($i1);
		if (is_string($i2)) $i1=floatval($i2);
		}
		if (!is_null($i2)) $this->b=array($i1,$i2); else $this->b=$i1;
		$this->preflen=$pfl;
	}
	function parse($str){
		$str=trim($str);
		if (preg_match("/^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$/",$str)){
			if (!InetAddr::parse($str)) return null;
			$this->preflen=32;
			return true;
		}
		if (preg_match("/^([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)\/([0-9]+)$/",$str,$matches)){
			if (!InetAddr::parse($matches[1])) return null;
			$this->preflen=intval($matches[2]);
			return true;
		}
		if (preg_match("/^([0-9\.]+)\/([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$/",$str,$matches)) {
		  if (!InetAddr::parse($matches[1])) return null;
      $ii=(intval($m[2]) << 24) | (intval($m[3]) << 16) | (intval($m[4]) << 8) | intval($m[5]);
      $ii=((~$ii) & 0xffffff)+1;
			$this->preflen=32-log($ii,2);
			return true;
		}
		if (preg_match("/^([0-9a-fA-F\.\:]+)$/",$str)){
			if (!InetAddr::parse($str)) return null;
			$this->preflen=128;
			return true;
		}
		if (!preg_match("/^([0-9a-fA-F\.\:]+)\/([0-9]+)$/",$str,$matches)) return null;
		if (!InetAddr::parse($matches[1])) return null;
		$this->preflen=intval($matches[2]);
		return true;
	}
	function str(){
		$ishost=false;
		if (is_array($this->b)) $ishost=($this->preflen==128); else $ishost=($this->preflen==32);
		return InetAddr::str().($ishost ? '':"/".$this->preflen);
	}
	function wildcard(){
		// only for ipv4
		$s="0.0.0.0";
		if ($this->preflen<32){
		 $i=(1 << (32-$this->preflen))-1;
		 $s=intval($i >> 24).'.'.(intval($i >> 16) & 255).'.'.(intval($i >> 8) & 255).'.'.(intval($i) & 255);
	  }
		return array(InetAddr::str(),$s);
	}
	function mask(){
		// only for ipv4
		$s="255.255.255.255";
		if ($this->preflen<32){
		 $i=((1 << (32-$this->preflen))-1) ^ 0xffffffff;
		 $s=intval($i >> 24).'.'.(intval($i >> 16) & 255).'.'.(intval($i >> 8) & 255).'.'.(intval($i) & 255);
	  }
		return array(InetAddr::str(),$s);
	}
	function normalize(){
		if (is_null($this->b)) return ;
		if (!is_array($this->b)){
			if (($this->preflen<1) || ($this->preflen>31)) {$this->preflen=32;return ;}
			$i=(1 << (32-$this->preflen))-1;
			$this->b=$this->b & ~$i;
			return true;
		}
		if (($this->preflen<1) || ($this->preflen>127)) {$this->preflen=128;return ;}
		if (NATIVE_64BIT){
		if ($this->preflen<64){
		 $i=(1 << (64-$this->preflen))-1;
		 $this->b[0]=$this->b[0] & ~$i;
		 $this->b[1]=0;
		}
		if ($this->preflen==64) $this->b[1]=0;
		if ($this->preflen>64){
		 $i=(1 << (64-($this->preflen-64)))-1;
		 $this->b[1]=$this->b[1] & ~$i;
		}
		} else
		if (USE_GMP){
		 if ($this->preflen<64){
		  $i=gmp_sub(gmp_sub(gmp_pow(2,64),1),gmp_sub(gmp_pow(2,64-$this->preflen),1));
		  $this->b[0]=gmp_and($this->b[0],$i);
		  $this->b[1]='0';
		 }
		 if ($this->preflen==64) $this->b[1]='0';
		 if ($this->preflen>64){
		  $i=gmp_sub(gmp_sub(gmp_pow(2,64),1),gmp_sub(gmp_pow(2,128-$this->preflen),1));
		  $this->b[1]=gmp_and($this->b[1],$i);
		 }
								   
		}
	}
	function is_equal($net){
		if (!is_object($net)) return false;
		if (get_class($net)=='InetNet' || is_subclass_of($net,'InetNet')){
			if ($net->preflen!=$this->preflen) return false;
		} else
		if (get_class($net)=='InetAddr' || is_subclass_of($net,'InetAddr')){
			if ($this->preflen!=($this->get_proto()==6 ? 128:32)) return false;
		}
		if ($net->get_proto()!=$this->get_proto()) return false;
		if (get_class($net)=='InetAddr' || is_subclass_of($net,'InetAddr')){
		    if (USE_GMP){
			if (!is_array($this->b)){
			 if (is_array($net->b)) return false;
			 if (!is_resource($this->b)) return $this->b==$net->b;
			 return gmp_cmp($this->b,$net->b)==0;
			}
			return gmp_cmp($this->b[0],$net->b[0])==0 && gmp_cmp($this->b[1],$net->b[1])==0;
		    }
		    else {
			if (!is_array($this->b)) return $this->b==$net->b;
			return $this->b[0]==$net->b[0] && $this->b[1]==$net->b[1];
		    }
		}
		return false;
	}
	function is_childnet($net){
		if (!is_object($net)) return false;
		if (get_class($net)=='InetNet' || is_subclass_of($net,'InetNet')){
			if ($net->preflen<=$this->preflen) return false;
		}
		if (get_class($net)=='InetAddr' || is_subclass_of($net,'InetAddr')){
			if ($net->get_proto()!=$this->get_proto()) return false;
			$q1=new InetNet();$q2=new InetNet();
			$q1->assign($this);$q2->assign($net);
			$q1->preflen=$this->preflen;$q2->preflen=$this->preflen;
			$q1->normalize();$q2->normalize();
			return $q1->is_equal($q2);
		}
		return false;
	}
	function is_intersect($net){
		if (!is_object($net)) return false;
		if (get_class($net)!='InetNet' && !is_subclass_of($net,'InetNet')) return null;
		if ($this->is_equal($net)) return true;
		if ($this->is_childnet($net)) return true;
		if ($net->is_childnet($this)) return true;
		return false;
	}
	function increment(){
		if (is_null($this->b)) return ;
		if (!is_array($this->b)){
			if (($this->preflen<1) || ($this->preflen>31)) {$this->preflen=32;return ;}
			$i=1 << (32-$this->preflen);
			$this->b+=$i;
			return true;
		}
		if (($this->preflen<1) || ($this->preflen>127)) {$this->preflen=128;return ;}
		if (USE_GMP){
		    if ($this->preflen<=64){
			$this->b[0]=gmp_add($this->b[0],gmp_pow(2,64-$this->preflen));
		    } else {
			$this->b[0]=gmp_add($this->b[0],gmp_pow(2,128-$this->preflen));
		    }
		}
		if ($this->preflen<=64){
		 $i=1 << (64-$this->preflen);
		 $this->b[0]+=$i;
		}
		if ($this->preflen>64){
		 $i=1 << (64-($this->preflen-64));
		 $this->b[1]+=$i;
		 //TODO: overflow
		}
		return $this;
	}
	function get_nextnet(){
		$ret=new InetNet();
		$ret->b=$this->b;
		$ret->preflen=$this->preflen;
		$ret->increment();
		return $ret;
	}
};

?>
