#!/usr/bin/perl
use strict;
use DBI;
use POSIX;
our @tables=('bgp_ipv4_log','bgp_vpnv4_log','bgp_ipv6_log','bgp_vpnv6_log','bgp_l2vpn_log');

sub rotate_table($$$);
my ($dbh,$tbn,@a,$postfix);
##
## TODO: Please correct MySQL Database credentials
##
$dbh=DBI->connect("dbi:mysql:bgplog:localhost","bgplogger","bgppwd123") or die("Unable to connect to DB");
$dbh->do("set names utf8");
##
##
##
@a=POSIX::localtime(POSIX::time());
$postfix=sprintf("%04u%02u01",$a[5]+1900,$a[4]+1);
foreach $tbn (@tables){
    rotate_table($dbh,$tbn,$postfix);
}
$dbh->disconnect;
exit 0;

sub rotate_table($$$){
    my ($dbh,$tablename,$postfix)=($_[0],$_[1],$_[2]);
    my ($sql,$sth,@data,$newtablename,$newcrt,$altmrg);
    print "Processing ",$tablename,"\n";
    $sql="show create table $tablename";
    $sth=$dbh->prepare($sql);
    return 0 unless ($sth);
    return 0 unless ($sth->execute());
    @data=$sth->fetchrow_array;
    $sth->finish;
    $newcrt=$data[1];
    $newtablename=$tablename.'_'.$postfix;
    $newcrt=~ s/MRG_MyISAM/MyISAM/g;
    $newcrt=~ s/$tablename/$newtablename/g;
    $newcrt=~ s/INSERT_METHOD=LAST//g;
    $newcrt=~ s/UNION=\(.*\)//g;
    $altmrg='';
    if ($data[1] =~/UNION=\((.*)\)/){
        $altmrg=$1.",".$newtablename;
    }
    else {
        $altmrg=$newtablename;
    }
    $altmrg="alter table $tablename union=($altmrg)";
    #print STDERR $newcrt;
    #print STDERR $altmrg;
    $dbh->do($newcrt) || return 0;
    $dbh->do($altmrg);
}

